<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

    <title>Task 30.10: Tạo form với Bootstrap</title>
</head>

<body>
    <div class="container mt-3">
        <form id="formId">
            <div class="form-group">
                <label class="">Email address</label>
                <input type="text" class="form-control" placeholder="Enter email" id="username" value = "Priscilla_Crist@yahoo.com" />
                <small>We'll never share your email with anyone else</small>
            </div>
            <div class="form-group">
                <label class="">Password</label>
                <input type="password" class="form-control" placeholder="Password" id="password" value = "SnDzyj3XxVm6Nj8" />
            </div>
            <div class="form-row">
                <div class="col">
                    <button class="btn btn-primary w-10" type = "submit">Submit</button>
                </div>
            </div>
        </form>
    </div>
    <script>
        "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_STATUS_CREATED = 201;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
        const gBASE_URL = "https://62458c222cfed18817229118.mockapi.io/users";
        const gBASE_URL_CONTACTS = "https://62458c222cfed18817229118.mockapi.io/contacts";
        var loginForm = document.getElementById("formId");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        loginForm.addEventListener("submit", (e) => {
            // Sử dụng preventDefault để loại bỏ hành động submit mặc định của form
            e.preventDefault();
            var vUserObject = {
                username: "",
                password: ""
            }
            getDataFromForm(vUserObject);
            var vValidate = validateData(vUserObject);
            if (vValidate == true) {
                // Gọi API
                var vXmlHttpLogin = new XMLHttpRequest();
                callLoginAPI(vXmlHttpLogin, vUserObject)
                vXmlHttpLogin.onreadystatechange =
                    function () {
                        if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                             // Xử lý kết quả trả về
                            xuLyKetQuaTraVe(vXmlHttpLogin);
                        }
                    }
            }
            // Tiếp theo thực hiện 4 bước để gọi api login
        });
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Lấy dữ liệu
        function getDataFromForm(paramUserObject) {
            var vUsernameElement = document.getElementById("username");
            var vPasswordElement = document.getElementById("password");
            paramUserObject.username = vUsernameElement.value;
            paramUserObject.password = vPasswordElement.value;
        }
        // Kiểm tra dữ liệu
        function validateData(paramUserObject) {
            if (validateEmail(paramUserObject.username) == false) {
                alert("Bạn nhập sai email!");
                return false;
            }
            return true;
        }
        // Kiểm tra email
        function validateEmail(mail) {
            if (/^\w+([\.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/.test(mail)) {
                return (true);
            }

            return (false)
        }
        // Gọi API
        function callLoginAPI(paramXMLHttpRequest, paramUserObject){
            var vParams = new URLSearchParams(paramUserObject);
            paramXMLHttpRequest.open("GET", gBASE_URL + "?" + vParams.toString(), true);
            paramXMLHttpRequest.send();
        }
        // Xử lý kết quả trả về
        function xuLyKetQuaTraVe(paramXMLHttpRequest){
            var vLoginInfo = paramXMLHttpRequest.responseText;
            console.log(vLoginInfo);
        }
    </script>
</body>

</html>